﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["GridData"] == null)
        {
            Session["GridData"] = GetEmployDepartmentDataSet();
            WebHierarchicalDataGrid1.DataSource = Session["GridData"];
            WebHierarchicalDataGrid1.DataBind();
        }
        else
        {
            WebHierarchicalDataGrid1.DataSource = Session["GridData"];
        }
        
    }

    private DataSet GetEmployDepartmentDataSet()
    {
        DataSet ds = new DataSet("EmployeeRecords");

        // Get the tables to use in the DataSet
        DataTable Employees = this.GetEmployees();
        DataTable Departments = this.GetDepartments();

        // Add the tables to the DataSet
        ds.Tables.Add(Departments);
        ds.Tables.Add(Employees);

        // Create the relationship between the tables.
        ds.Relations.Add("DepartmentEmployee", Departments.Columns["DepartmentID"], Employees.Columns["Department"]);
        return ds;
    }

    private DataTable GetDepartments()
    {
        DataTable dt = new DataTable("Departments");
        dt.Columns.Add("DepartmentID", typeof(int));
        dt.Columns.Add("DepartmentName", typeof(string));
        dt.Columns.Add("Number", typeof(int));

        for (int i = 0; i < 8; i++)
        {
            dt.Rows.Add(new object[] { i, "", i });
        }

        dt.PrimaryKey = new DataColumn[] { dt.Columns["DepartmentID"] };

        return dt;
    }

    private DataTable GetEmployees()
    {
        return this.GetEmployees(24);
    }

    private DataTable GetEmployees(int count)
    {
        DataTable dtData = new DataTable("Employees");

        dtData.Columns.Add("EmployeeID", typeof(int));
        dtData.Columns.Add("Name", typeof(string));
        dtData.Columns.Add("OnSite", typeof(bool));
        dtData.Columns.Add("DateOfHire", typeof(DateTime));
        dtData.Columns.Add("Department", typeof(int));
        dtData.Columns.Add("Site", typeof(string));
        dtData.Columns.Add("OtherNumber", typeof(int));


        for (int i = 0; i < count; i++)
        {
            dtData.Rows.Add(new object[] { i, string.Format("Name {0}", i), (i % 2 == 0), DateTime.Today.Date.AddDays(-1 * i), i % 8, "http://www.google.com", i });
        }

        dtData.PrimaryKey = new DataColumn[] { dtData.Columns["EmployeeID"] };

        return dtData;
    }

    protected void WebHierarchicalDataGrid1_InitializeRow(object sender, Infragistics.Web.UI.GridControls.RowEventArgs e)
    {
        int level = ((Infragistics.Web.UI.GridControls.ContainerGridRecord)(e.Row)).Level;
        if (level == 0)
        {
            e.Row.Items[3].Value = "0.00";
        }
    }

    protected void WebHierarchicalDataGrid1_PreRender(object sender, EventArgs e)
    {
        //DataSet ds = (DataSet)Session["GridData"];
        //int rowCount = ds.Tables[0].Rows.Count;
        int rowsCount = WebHierarchicalDataGrid1.Rows.Count;
        int rowCount = WebHierarchicalDataGrid1.GridView.Rows.Count;
    }
}